﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace Qnomad.Outlining
{
	internal class ITreeNodeAdapterImpl<T> : ITreeNodeAdapter<ITreeNode<T>>
		where T : ITreeNode<T>
	{
		#region Object Creation

		private ITreeNodeAdapterImpl() { }
		/*private static readonly Dictionary<Type, object> instances = new Dictionary<Type, object>();

		private static ITreeNodeAdapter<ITreeNode<T>> GetInstance<T>()
			where T : ITreeNode<T>
		{
			Type type = typeof( T );
			object result;
			if ( !instances.TryGetValue( type, out result ) ) {
				result = new ITreeNodeAdapterImpl<T>();
				instances[type] = result;
			}
			return (ITreeNodeAdapter<ITreeNode<T>>)result;
		}*/
		private static ITreeNodeAdapterImpl<T> instance;

		public static ITreeNodeAdapterImpl<T> Instance
		{
			get
			{
				if ( instance == null )
					instance = new ITreeNodeAdapterImpl<T>();
				return instance;
			}
		}

		#endregion Object Creation

		public bool HasSubItems( ITreeNode<T> treeNode )
		{
			return treeNode.HasSubItems;
		}

		public IEnumerable<ITreeNode<T>> GetSubItems( ITreeNode<T> treeNode )
		{
			foreach ( var item in treeNode.SubItems )
				yield return item;
		}

		public ITreeNode<T> GetParent( ITreeNode<T> treeNode )
		{
			return treeNode.Parent;
		}
	}
}
