using System;
using System.Windows;
using System.Configuration;

namespace Qnomad.Demos.PresentationModel {

	/// <summary>
	/// Interaction logic for App.xaml
	/// </summary>
	public partial class App : System.Windows.Application {
		private static SampleListContainer sampleListContainer;

		public static SampleListContainer SampleListContainer {
			get {
				if ( sampleListContainer == null ) {
					//Build sample domain-model data:
					sampleListContainer = new SampleListContainer();
					Representative obama = new Representative( "Barack Obama" );
					Representative specter = new Representative( "Arlen Specter" );
					Representative clinton = new Representative( "Hillary Clinton" );
					Representative mcCain = new Representative( "John McCain" );
					sampleListContainer.SampleList.Add( obama );
					sampleListContainer.SampleList.Add( specter );
					sampleListContainer.SampleList.Add( clinton );
					sampleListContainer.SampleList.Add( mcCain );
					sampleListContainer.SampleList.Add( new Represented( "Chicago", obama ) );
					sampleListContainer.SampleList.Add( new Represented( "Philadelphia", specter ) );
					sampleListContainer.SampleList.Add( new Represented( "Albany", clinton ) );
					sampleListContainer.SampleList.Add( new Represented( "Phoenix", mcCain ) );
				}
				return sampleListContainer;
			}
		}
	}
}
